/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import org.threeten.bp.LocalDate;

/**
 * Information related to the car rental
 */
@ApiModel(description = "Information related to the car rental")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class CarRentalInformation {
  @SerializedName("from")
  private LocalDate from = null;

  @SerializedName("to")
  private LocalDate to = null;

  @SerializedName("country_origin")
  private String countryOrigin = null;

  @SerializedName("city_origin")
  private String cityOrigin = null;

  @SerializedName("country_destination")
  private String countryDestination = null;

  @SerializedName("city_destination")
  private String cityDestination = null;

  @SerializedName("is_international_trip")
  private Boolean isInternationalTrip = null;

  @SerializedName("rental_company")
  private String rentalCompany = null;

  @SerializedName("reservation_number")
  private String reservationNumber = null;

  @SerializedName("vehicle_type")
  private String vehicleType = null;

  public CarRentalInformation from(LocalDate from) {
    this.from = from;
    return this;
  }

   /**
   * Starting date of the car rental - ISO 8601 format (YYYY-MM-DD)
   * @return from
  **/
  @ApiModelProperty(example = "2017-05-01", required = true, value = "Starting date of the car rental - ISO 8601 format (YYYY-MM-DD)")
  public LocalDate getFrom() {
    return from;
  }

  public void setFrom(LocalDate from) {
    this.from = from;
  }

  public CarRentalInformation to(LocalDate to) {
    this.to = to;
    return this;
  }

   /**
   * Ending date of the car rental - ISO 8601 format (YYYY-MM-DD)
   * @return to
  **/
  @ApiModelProperty(example = "1989-05-09", value = "Ending date of the car rental - ISO 8601 format (YYYY-MM-DD)")
  public LocalDate getTo() {
    return to;
  }

  public void setTo(LocalDate to) {
    this.to = to;
  }

  public CarRentalInformation countryOrigin(String countryOrigin) {
    this.countryOrigin = countryOrigin;
    return this;
  }

   /**
   * Country of origin of the trip - ISO-3166-1 alpha-2 format (2 letter codes)
   * @return countryOrigin
  **/
  @ApiModelProperty(example = "fr", value = "Country of origin of the trip - ISO-3166-1 alpha-2 format (2 letter codes)")
  public String getCountryOrigin() {
    return countryOrigin;
  }

  public void setCountryOrigin(String countryOrigin) {
    this.countryOrigin = countryOrigin;
  }

  public CarRentalInformation cityOrigin(String cityOrigin) {
    this.cityOrigin = cityOrigin;
    return this;
  }

   /**
   * City of origin of the trip
   * @return cityOrigin
  **/
  @ApiModelProperty(example = "paris", value = "City of origin of the trip")
  public String getCityOrigin() {
    return cityOrigin;
  }

  public void setCityOrigin(String cityOrigin) {
    this.cityOrigin = cityOrigin;
  }

  public CarRentalInformation countryDestination(String countryDestination) {
    this.countryDestination = countryDestination;
    return this;
  }

   /**
   * Country of destination of the trip - ISO-3166-1 alpha-2 format (2 letter codes)
   * @return countryDestination
  **/
  @ApiModelProperty(example = "en", value = "Country of destination of the trip - ISO-3166-1 alpha-2 format (2 letter codes)")
  public String getCountryDestination() {
    return countryDestination;
  }

  public void setCountryDestination(String countryDestination) {
    this.countryDestination = countryDestination;
  }

  public CarRentalInformation cityDestination(String cityDestination) {
    this.cityDestination = cityDestination;
    return this;
  }

   /**
   * City of destination of the trip
   * @return cityDestination
  **/
  @ApiModelProperty(example = "london", value = "City of destination of the trip")
  public String getCityDestination() {
    return cityDestination;
  }

  public void setCityDestination(String cityDestination) {
    this.cityDestination = cityDestination;
  }

  public CarRentalInformation isInternationalTrip(Boolean isInternationalTrip) {
    this.isInternationalTrip = isInternationalTrip;
    return this;
  }

   /**
   * Define if the trip is international (in opposition of domestic)
   * @return isInternationalTrip
  **/
  @ApiModelProperty(example = "false", value = "Define if the trip is international (in opposition of domestic)")
  public Boolean isIsInternationalTrip() {
    return isInternationalTrip;
  }

  public void setIsInternationalTrip(Boolean isInternationalTrip) {
    this.isInternationalTrip = isInternationalTrip;
  }

  public CarRentalInformation rentalCompany(String rentalCompany) {
    this.rentalCompany = rentalCompany;
    return this;
  }

   /**
   * Name of the rental company
   * @return rentalCompany
  **/
  @ApiModelProperty(value = "Name of the rental company")
  public String getRentalCompany() {
    return rentalCompany;
  }

  public void setRentalCompany(String rentalCompany) {
    this.rentalCompany = rentalCompany;
  }

  public CarRentalInformation reservationNumber(String reservationNumber) {
    this.reservationNumber = reservationNumber;
    return this;
  }

   /**
   * reservation_number
   * @return reservationNumber
  **/
  @ApiModelProperty(value = "reservation_number")
  public String getReservationNumber() {
    return reservationNumber;
  }

  public void setReservationNumber(String reservationNumber) {
    this.reservationNumber = reservationNumber;
  }

  public CarRentalInformation vehicleType(String vehicleType) {
    this.vehicleType = vehicleType;
    return this;
  }

   /**
   * Type of the rented vehicle
   * @return vehicleType
  **/
  @ApiModelProperty(value = "Type of the rented vehicle")
  public String getVehicleType() {
    return vehicleType;
  }

  public void setVehicleType(String vehicleType) {
    this.vehicleType = vehicleType;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CarRentalInformation carRentalInformation = (CarRentalInformation) o;
    return Objects.equals(this.from, carRentalInformation.from) &&
        Objects.equals(this.to, carRentalInformation.to) &&
        Objects.equals(this.countryOrigin, carRentalInformation.countryOrigin) &&
        Objects.equals(this.cityOrigin, carRentalInformation.cityOrigin) &&
        Objects.equals(this.countryDestination, carRentalInformation.countryDestination) &&
        Objects.equals(this.cityDestination, carRentalInformation.cityDestination) &&
        Objects.equals(this.isInternationalTrip, carRentalInformation.isInternationalTrip) &&
        Objects.equals(this.rentalCompany, carRentalInformation.rentalCompany) &&
        Objects.equals(this.reservationNumber, carRentalInformation.reservationNumber) &&
        Objects.equals(this.vehicleType, carRentalInformation.vehicleType);
  }

  @Override
  public int hashCode() {
    return Objects.hash(from, to, countryOrigin, cityOrigin, countryDestination, cityDestination, isInternationalTrip, rentalCompany, reservationNumber, vehicleType);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CarRentalInformation {\n");
    
    sb.append("    from: ").append(toIndentedString(from)).append("\n");
    sb.append("    to: ").append(toIndentedString(to)).append("\n");
    sb.append("    countryOrigin: ").append(toIndentedString(countryOrigin)).append("\n");
    sb.append("    cityOrigin: ").append(toIndentedString(cityOrigin)).append("\n");
    sb.append("    countryDestination: ").append(toIndentedString(countryDestination)).append("\n");
    sb.append("    cityDestination: ").append(toIndentedString(cityDestination)).append("\n");
    sb.append("    isInternationalTrip: ").append(toIndentedString(isInternationalTrip)).append("\n");
    sb.append("    rentalCompany: ").append(toIndentedString(rentalCompany)).append("\n");
    sb.append("    reservationNumber: ").append(toIndentedString(reservationNumber)).append("\n");
    sb.append("    vehicleType: ").append(toIndentedString(vehicleType)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

